$(function(){
    //init radio buttons
    init_radio();
    //init new pass page
    init_searchbar();
    init_new_pass_ui();
    init_submitpass();
    init_newpass_dialog()
    //init accordions
    init_accordion_ui();
    //init my_pass page
    init_mypass_delete();
    init_delete_dialog();
    init_sign_out();
    init_sign_in();
});

/**************************
 *
 *     NEW PASS PAGE
 *
 ***************************/
function init_newpass_dialog(){
    $( "#dialog-pass-made" ).dialog({
        resizable: false,
    	height:170,
        autoOpen: false,
        dragable: false,
    });
}
//adds the JQUERY UI style and events to the add new pass text form
function init_searchbar() {
    $("#search").autocomplete({
	source: loadSource,
	select: function(ev,ui) {
	    $("#new_pass").fadeIn();
	}
    });
    $('#search').keydown(function(event){
        var code = event.which;
        if(code == 13) {
            $('#new_pass').fadeIn();
            $(this).autocomplete('close');
        }
    });
}
//loads JSON source of a list of all of the students
function loadSource(req, add) {
	 $.getJSON("/students_json/" + req.term,function(data) {
                var suggestions = [];
		$.each(data, function(i, val){
		    var name = val.fields.firstName + " " + val.fields.lastName;
		    suggestions.push(name); 
		});
                add(suggestions);
             });
}
//styles the new pass form
function init_new_pass_ui() {
    $("#datepicker").datepicker();
	$("#check_a").button();
    $("#check_b").button();
}

//styles the submit pass button and adds a mouse event
function init_submitpass() {
	$("#submit_pass").button();
	$("#submit_pass").click(submitPass);
}
//submit pass mouse event--collects all of the data from the forms and sends it via AJAX POST to django view new_pass. 
function submitPass() {
	var student = $("#search").val();
	var date = $("#datepicker").val();
  var note = $('#new_pass_notes').val();
	var data = {student:student , date:date , note:note};
	$.ajax({
		type:'POST',
		url: '/newpass/',
		data: data,
		success: submitPassSuccess,
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			alert(XMLHttpRequest.responseText);
		}
	});
    
}
//the success function for submitPass
function submitPassSuccess(data, textStatus, xhr) {
    $('#new_pass').fadeOut();
    reload_my_passes();
    $('#dialog-pass-made').dialog('open');
}


/********************
 *
 *   RADIO BUTTONS
 *
 **********************/
//styles the top navigation buttons
function init_radio() {
    $("#navigation").buttonset();
    $('#radio1').click(show_roster);
    $('#radio2').click(show_search);
    $('#radio3').click(show_my_passes);
}
function show_roster(){
	$(".pass_page").hide();
	$("#my_passes").hide();
  $(".roster_page").fadeIn();	
}
function show_search(){
	$(".roster_page").hide();
	$("#student_search").fadeIn();
	$("#my_passes").hide();
}
function show_my_passes(){
	$(".roster_page").hide();
	$(".pass_page").hide();
	$("#my_passes").fadeIn();
}


/***********************
 *
 *    ACCORDION
 *
 ***********************/
//styles the 
function init_accordion_ui() {
    $(".list").accordion({
	autoHeight: false,
	navigation: true,
    alwaysOpen: false,
    active: false,
	collapsible: true
    });
}

function sign_out(passes){
    var pass =0;
    if(passes.nodeType == 1){
        pass = passes.value;
    }
    else{
        for(var i=0;i<passes.length;i++){
            if(passes[i].checked){
                pass = passes[i].value;
                break;
            }
        }
    }
    var data = {passID:pass};
    $.ajax({
        type:'POST',
        url:'/sign_out/',
        data:data,
        success: function(){},
        error: function(){},
    });
    return false;
}

function init_sign_out(){
    $('.sign_out').button();
}

function init_sign_in(){
    $('.sign_in').button();
}

function sign_in(id){
    alert(id);
    var data = {id:id}
    $.ajax({
        type:'POST',
        url:'/sign_in/',
        data:data,
        success: function(){alert('ITS ALIVE!');},
        error: function(){alert('NOT SO MUCH!');},
    });
    return false;
}
/*
//styles the sign out button under Roster
function init_sign_out() {
    $(".sign_out").button();
    $('.sign_out').click(sign_out);
}


function sign_out(){
    id = this.id;
    id = id+'_form'
    if(document.period.period[1].checked)
        checkboxes = document.getElementById(id).PartB;
   else
        checkboxes = document.getElementById(id).PartA;
    answer = 'error';
    alert(document.getElementById(id).PartA.length);
    for(var i=0;i<checkboxes.length;i++){
         alert('in Loop');
        if(checkboxes[i].checked){
            answer = checkboxes[i].value;
            break;
        }
    }
    alert(answer);
}
*/

/***********************
 *
 *    MY PASSES
 *
 **********************/
var delete_id;

function init_delete_dialog(){
    $( "#dialog-confirm-delete" ).dialog({
        resizable: false,
    	height:170,
    	modal: true,
        autoOpen: false,
    	buttons: {
            "Delete?": function() {
	    		$( this ).dialog( "close" );
                delete_pass('close');
            },
	    	Cancel: function() {
        		$( this ).dialog( "close" );
                $('#my_pass_list').accordion( "option", "disabled", false );
        	}
        }
    });
}
//Set close as a clickable
function init_mypass_delete(){
    $('.close_button').click(confirm_delete);
}
function confirm_delete(){
    delete_id = this.id;
    $('#my_pass_list').accordion( "option", "disabled", true );
    $('#dialog-confirm-delete').dialog('open');
}
//handels removing a pass from the mypass screen
function delete_pass(){
   var id = delete_id;
    var data ={id:id}
    $.ajax({
        type:'POST',
        url:'/removepass/',
        data: data,
        success: deletePassSuccess,
        error: function(XMLHttpRequest, textStatus, errorThrown) {
			alert(errorThrown);
		}
     });
    $('#'+id+'div').fadeOut();
    $('#'+id+'head').fadeOut();
    $('#my_pass_list').accordion( "option", "disabled", false );
}
//the success function for delete_pass
function deletePassSuccess(data, textStatus, xhr) {

}


/******************************
 *
 *    PAGE RELOADERS
 *
 *******************************/
function reload_my_passes(){
    $.ajax({
        type:'GET',
		url: 'ajax/load_pass/',
		success: function(data,textStatus,xhr) {
            $('#my_passes').html(data);
            init_accordion_ui();
            init_mypass_delete();
        }
    });                          
}

function reload_my_roster(){
    $.ajax({
        type:'GET',
        url:'ajax/load_roster',
        success:  function(data,textStatus,xhr){
            $('#roster').html(data);
            init_accordion_ui();
            init_radio();
            init_sign_out();
        }
    })
}

function reload_incomming(){
        $.ajax({
        type:'GET',
        url:'ajax/load_incomming',
        success:  function(data,textStatus,xhr){
            $('#incomming').html(data);
            init_accordion_ui();
            init_sign_in();
            init_sign_out();
        }
    })
}