# Create your views here.
from django.http import HttpResponse , HttpResponseRedirect, HttpResponseServerError
from django.shortcuts import render_to_response
from seminar.tracker.models import *
from django.core import serializers
import json
import stomp
from django.template import Template,Context
import datetime

##
#HOME METHODS
##
def home(request):
    if not request.user.is_authenticated():
    	return HttpResponseRedirect('/accounts/login/')
    else:
    	user = request.user.get_profile()
    	return render_to_response('home.dhtml',locals())

def home_redirect(request):
    if not request.user.is_authenticated():
        return HttpResponseRedirect('/accounts/login/')
    else:
        return HttpResponseRedirect('/accounts/profile/')


##
#POST METHODS
##
def new_pass(request):
    if not request.user.is_authenticated():
	return HttpResponseRedirect('/accounts/login/')
    if not request.method == 'POST':
	return HttpResponseServerError('Request was not a POST')
    post = request.POST.copy()
    if not post.has_key('student') and post.has_key('date') and post.has_key('note'):
	return HttpResponseServerError('Invalid POST keys')
    if not len(post['student']) > 0:
	return HttpResponseServerError('Please give a student name')
    if not len(post['date']) > 0:
	return HttpResponseServerError('Please select a date')
    date_info = post['date'].split("/")
    try:
	    date = datetime.date(month = int(date_info[0]), day = int(date_info[1]), year = int(date_info[2]))
    except:
	return HttpResponseServerError('Invalid Date')
    try:
      names = post['student'].split()
      student = Student.objects.get(firstName=names[0], lastName=names[1])
    except:
	return HttpResponseServerError('Invalid student name')
    dest = request.user.get_profile()
    note = post['note']
    new_pass = Pass(student=student, destination=dest, date=date, note=note)
    new_pass.save()
    new_pass_msg = json.dumps({'name':new_pass.student.firstName})
    conn = stomp.Connection()
    conn.start()
    conn.connect()
    conn.send('RELOAD ROSTER', destination = '/'+new_pass.student.seminar.room)
    return HttpResponse()
    

def delete_pass(request):
    if not request.user.is_authenticated():
	return HttpResponseServerError('Setion Terminated... Please Refresh the page')
    if not request.method == 'POST':
	return HttpResponseServerError('Not a POST')
    post = request.POST.copy()
    if not post.has_key('id'):
	return HttpResponseServerError('"id" not in POST')
    old_pass = Pass.objects.get(id=post['id'])
    old_pass.delete()
    conn = stomp.Connection()
    conn.start()
    conn.connect()
    conn.send('RELOAD ROSTER', destination = '/'+old_pass.student.seminar.room)
    return HttpResponse()
    
def sign_out(request):
    if not request.user.is_authenticated():
	return HttpResponseServerError('Setion Terminated... Please Refresh the page')
    if not request.method == 'POST':
	return HttpResponseServerError('Not a POST')
    post = request.POST.copy()
    if not post.has_key('passID'):
	return HttpResponseServerError('Incompleate POST data')
    active_pass = Pass.objects.get(id= post['passID'])
    active_pass.active = True
    active_pass.in_transit = True
    active_pass.save()
    conn = stomp.Connection()
    conn.start()
    conn.connect()
    conn.send('RELOAD INCOMMING',destination='/'+active_pass.destination.room)
    conn.send('RELOAD ROSTER',destination='/'+active_pass.student.seminar.room)
    return HttpResponse();
    
def sign_in(request):
    if not request.user.is_authenticated():
	return HttpResponseServerError('Setion Terminated.... Please Refresh the page')
    if not request.method == 'POST':
	return HttpResponseServerError('Not a POST')
    post = request.POST.copy()
    if not post.has_key('id'):
	return HttpResponseServerError('Incompleate POST data')
    active_pass = Pass.objects.get(id=post['id'])
    active_pass.in_transit = False
    active_pass.save()
    conn = stomp.Connection()
    conn.start()
    conn.connect()
    conn.send('RELOAD INCOMMING',destination='/'+active_pass.destination.room)
    conn.send('RELOAD ROSTER',destination='/'+active_pass.student.seminar.room)
    return HttpResponse();


##
#JSON METHODS
##
def all_students_json(request):
    students = Student.objects.all()
    data = serializers.serialize("json",students)
    return HttpResponse(data,"application/json")

def query_students_json(request, query):
    query = str(query)
    if " " in query:
        q = query.split(" ")
        students = Student.objects.filter(firstName__startswith=q[0]) | Student.objects.filter(lastName__startswith=query[1])
	data = serializers.serialize('json',students)
	return HttpResponse(data, 'application/json')
    else:
        students = Student.objects.filter(firstName__startswith=query) | Student.objects.filter(lastName__startswith=query)
        data = serializers.serialize("json",students)
        return HttpResponse(data,"application/json")
